<?xml version="1.0" ?>
<xsl:stylesheet
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version='1.0'>
<xsl:output method="html"/>


<xsl:template match="object">
object  <xsl:value-of select="@name"/> {
0 0 0
0 0 0
shape {
vts { <xsl:value-of select="@vertices"/>  }
pls { <xsl:value-of select="@faces"/>  }
<!-- tex { unknown } -->

<xsl:apply-templates select="//vertex" /> 

<xsl:apply-templates select="//face" /> 
}
</xsl:template> 


<xsl:template match="vertex">
vtx { <xsl:apply-templates/> 
1 1 1 1
0 0
}
</xsl:template> 

<xsl:template match="face">

ply {  
pes { <xsl:value-of select="@count"/> }
<xsl:apply-templates select="vertexid" /> 
}
</xsl:template> 

<xsl:template match="vertexid">
ple { <xsl:value-of select="@id"/> }</xsl:template> 


</xsl:stylesheet>