
void trace(Scene const * const s)
{
  int i = 0, io = 0;

  Face f;
  Object o;
  float r,g,b,a;
  unsigned int ui;
  
  glColor3f(1,1,1);
  
  for(io=0; io < s->no; io++) {
    o = s->vo[io];

    glBegin(GL_TRIANGLES);  
    for( i=0; i < o.nf; i++) {
      f = o.vf[i]; //printFace(f);
      convertColorStringToRGBAFloat( f.material, &r, &g, &b , &a, &ui);
      glColor3f(r,g,b);
      glVertex3f( o.vv[ f.a ].x , o.vv[ f.a ].y , o.vv[ f.a ].z );
      glVertex3f( o.vv[ f.b ].x , o.vv[ f.b ].y , o.vv[ f.b ].z );
      glVertex3f( o.vv[ f.c ].x , o.vv[ f.c ].y , o.vv[ f.c ].z );
    }
    glEnd();
  }
  
  //debug("- trace"); 
}
