#!gmake
# $Id: mk-c.mk,v 1.1.1.1 2004/03/30 12:09:39 rzr Exp $
# Generated automatically from Makefile.in by configure.
#_MAKEFILE___________________________________________[ http://RzR.online.FR ]___
#
# This is a generic makefile for C++ programs
# Author: Philippe COVAL - http://rzr.online.fr - mailto:philc(a)writeme.com
# Version:1999.11.29/ $date$ /d
# Notes: This makefile will probally ONLY run with gnumake
#----------------------------------------------------[ http://RzR.online.FR ]---
PROJECT ?= $(shell basename `pwd`)
NAME ?=$(PROJECT)
FILES ?=${PROJECT}
TARGET ?= $(NAME)${EXESUFFIX}
TARGETSMAIN ?= ${TARGET}
OBJS ?= ${FILES:=.o}

CC ?= gcc
LD ?= gcc

.SUFFIXES: .c .cpp .cxx .o .fl .inl .h .hpp .hxx .hh .cc

#.SILENT:
# You must define your Architecture here with `uname -s`
#OS = 'shell uname -s' or WIN32, CYGWIN_95-4.0 ...
#OS := $(shell uname -s  | sed -e s/\\W/_/g )
# Place for compiled objects
ROOTDIR ?=../
BINDIR ?= ../bin/
OBJDIR ?= ../tmp/
SRCDIR ?=./
#$(ROOTDIR)src
DIRPATH +=$(OBJDIR) $(BINDIR) $(SRCDIR)
#VPATH=$(DIRPATH)

# use OBJDIR instead but configure Overide the VPATH
#bindir, libdir, includedir
#----------------------------------------------------[ http://RzR.online.FR ]---
SRCS ?=$(wildcard $(SRCDIR)*.cpp $(SRCDIR)*.c $(SRCDIR)*.fl $(SRCDIR)*.cxx)
FILES ?=$(SRCS:.c=)
#SRCS=$(FILES:=.c)
OBJS ?=$(FILES:=.o)
#SRCS ?=$(FILES:=.c)
TARGETSMAIN ?= $(TARGET)

ifeq ($(STATIC),1)
TARGETSLIBS += lib$(NAME).a
else
TARGETSLIBS += lib$(NAME).so
endif


default: all

all: $(DIRPATH) $(OBJS) $(TARGETSLIBS) $(TARGETSMAIN)


# vpath != VPATH , and is preserved w/ ./configure
vpath %.cpp %.c %.cc %.cxx %.C %.fl %.h %.hpp %.H %.hxx $(SRCDIR)
vpath %.o %.obj		$(OBJDIR)
vpath % %.exe		$(BINDIR)

#----------------------------------------------------[ http://RzR.online.FR ]---
# Linker
LIBSDIST ?= 
LIBSMINE ?=
LIBPATH ?=

LDLIBS  ?= $(LIBSMINE) $(LIBSDIST) $(LIBSOS)

LDFLAGS ?=
#----------------------------------------------------[ http://RzR.online.FR ]---
DEFINES += -D$(OS)
INCPATH +=  
CXXFLAGS += $(DEFINES) $(INCPATH)


DIRPATH ?=$(OBJDIR) $(BINDIR) $(SRCDIR)
# use DIRPATH instead of VPATH
VPATH=$(DIRPATH)			# (./configure overide VPATH)
vpath=$(DIRPATH)

#-------------------------------------------------------[ http://RzR.online.FR ]----
${TARGET}: ${OBJS}
	@mkdir -p ${BINDIR}
	cd ${OBJDIR} && \
	${LD} -o ${BINDIR}${@F} $(^F) ${LDFLAGS} ${LDLIBS} ${LIBPATH}
	@echo "$@/$^"
%: %.o
	@echo "$@ / $^ LDFLAGS=${LDFLAGS}"
	cd $(OBJDIR) && \
	${LD} -o ${BINDIR}${@F} $(^F) ${LDFLAGS} ${LDLIBS} ${LIBPATH}

lib$(NAME).so: $(OBJS)
	@mkdir -p ${BINDIR}
	cd $(OBJDIR) &&\
	${CC} -shared -o $(BINDIR)$(@F) $(^F)

lib$(NAME).a: $(OBJS)
	cd $(OBJDIR) &&\
	ar rc $(BINDIR)$(@F) $(^F)
# Implicit rules / normally this should not be modified
.cpp.o .cxx.o .C.o .CC.o .CPP.o .CXX.o:
	@mkdir -p ${OBJDIR}
	$(CXX) -c -o $(OBJDIR)$@ $(CXXFLAGS) $(DEFINES) $(INCPATH) $(SRCDIR)$<
.c.o:
	@mkdir -p ${OBJDIR}
	$(CC) -c -o $(OBJDIR)$@ $(CCFLAGS)   $(DEFINES) $(INCPATH) $(SRCDIR)$<

.fl.cxx .fl.h .fl.cpp:
	fluid -c $(SRCDIR)$<

# Dirs #$(OBJDIR) $(SRCDIR) $(BINDIR) :
.PHONY: $(DIRPATH) 

#$(DIRPATH) :
${BINPATH}:
	@-mkdir -p $@ 
#-------------------------------------------------------[ http://RzR.online.FR ]----
# Common Explicit directives

run: default exec

#DATA_M3D ?= $(HOME)/data/seq-armel/m3d/data
#/arch_dd/pcoval/seq-tabor/m3d/data #../data/data

exec: $(BINDIR)$(TARGET)
	cd $(BINDIR) && time $< $(DATA_M3D)


ddd: $(BINDIR)$(TARGET)
	cd $(BINDIR) && ddd $< $(DATA_M3D) &

test: clean run clean

print:
	a2ps $(PRINTFILES)

clean:
	@echo ... cleanup your room / or no tv
	@rm *.o  *~ \#*  *.bak hs~* $(TARGET) a.out $(OBJDIR)*  core; \
	rm -rf $(OBJDIR)
	-$(SHELL rehash)
	@echo $@/

clean-bin:
	@echo ... cleanup your room / or no tv
	rm *.o  *~ \#*  *.bak hs~* $(TARGET) a.out   core; \
	rm -rf $(LIBPATH) $(BINDIR) \
	@echo $@/

clean-all: clean clean-bin
	rm -rf ../bin.* ../tmp.* ../lib.* depend.mk
	@echo $@/

rebuild: clean default

doc:
	rm -rf ../doc-api ;\
	doc++ -d ../doc-api -p *.hpp *.h *.H *.hxx

install:
	install -d ${DESTDIR}/usr/local/bin
	install -s ${TARGET} ${DESTDIR}/usr/local/bin/
#-------------------------------------------------------[ http://RzR.online.FR ]----
# whatever you want : (the right place to add specifics directives)
ls:
	ls $(BINDIR)
xrun:
	xterm -e $(MAINTARGET) &
modes:
	chmod a-x *


info:
	@echo OBJDIR=$(OBJDIR)
	@echo BINDIR=$(BINDIR)
	@echo OBJS=[$(OBJS)]
	@echo OS=$(OS)
	@echo $(SRCS) $(FILES) [$(OBJS)]
	@echo LD_LIBRARY_PATH=$(LD_LIBRARY_PATH)
	@echo VPATH=[$(VPATH)]
	$(CXX) --version
	gmake --version
	arch
	uname -a
#	env
#	@echo TARGETS=$(TARGETS)
#-------------------------------------------------------[ http://RzR.online.FR ]----
#-include mkdepend-$(OS)-$(CXX)-$(VERSION)-$(HOST)-$(USER).mk
mkdepend-$(OS)-$(CXX)-$(VERSION)-$(HOST)-$(USER).mk:
	echo $(OS) $(HOST) $(HOME)
	$(CXX) -M $(CXXFLAGS) $(INCPATH) $(SRCS) > $@

#_______________________________________________________[ http://RzR.online.FR ]____
# $Id: mk-c.mk,v 1.1.1.1 2004/03/30 12:09:39 rzr Exp $
