/* #ident "$Id: color3ds.h,v 1.1.1.1 2004/03/30 12:09:25 rzr Exp $" */
#ifndef color3ds_h_ 
#define color3ds_h_ 
/**
 * Unstable 
 * @author: www.Philippe.COVAL.online.fr - Rev: $Author: rzr $ 
 * Copyright: GPL @ http://rzr.online.fr/licence.htm
 **/

int convertColorUint32ToRGB(unsigned int const src, char* dest);

int convertColorRGBFloatToString(float const r, float const g, float const b,
                                 const float a, char* dest);

int convertColorRGBFloatToRGB8(float const r, float const g, float const b,
                               unsigned char * dr, 
                               unsigned char * dg,unsigned char * db);

int convertColorRGBFloatToAnsi(float const r, float const g, float const b,
                               int * res);

int convertColorToRGB8(unsigned int const src, 
                       unsigned char* r, unsigned char* g, unsigned char* b,
                       unsigned  char* a);

int convertColorToRGBFloat(unsigned int const src,
                           float* r, float* g, float* b , float *a);

int convertColorStringRGBAToRGBA8(char const * const p,
                                  unsigned char *r, unsigned char* g, 
                                  unsigned char* b, unsigned char* a,
                                  unsigned int* dest);

int convertColorStringRGBAToRGBAFloat(char const * const p,
                                      float *r, float* g, float* b, float* a,
                                      unsigned int* dest);

int convertColorStringToRGBAFloat(char const * const p,
                                  float *r, float* g, float* b, float* a,
                                  unsigned int* dest);
///
unsigned int getColor(char const * const p);
///
unsigned int getColorRGB(unsigned char* r, unsigned char*g, unsigned char*b , 
                         char const * const p) ;
///
unsigned int getColorRGBFloat(float* r, float*g, float*b , float *a,
                              char const * const p) ;
/// r010g256b0a0
int getColorEncodedUint32(unsigned int const src, char* dest);

unsigned int getColorEncoded(unsigned char*r, unsigned char* g, 
                             unsigned char* b, unsigned char* a,
                             char const * const p);

int getColorTable(char const * const src, unsigned int * dest);

#endif //_h_ inclusion 
//$Id: color3ds.h,v 1.1.1.1 2004/03/30 12:09:25 rzr Exp $
