/* #ident "$Id: parse3ds.h,v 1.1.1.1 2004/03/30 12:09:28 rzr Exp $" */
/**
 * @author: www.Philippe.COVAL.online.fr - Rev: $Author: rzr $ 
 * Copyright: GPL @ http://rzr.online.fr/licence.htm
 **/
#ifndef parse3ds_h_
#define parse3ds_h_
#include <stdio.h>
#include "types3d.h"

///
int errorIO(FILE* f,int const t, const char *  msg);
///
char* skipafter(char* src, char* pat);
///
int parse3dsAscii(FILE* f, Object* o);
///
int load3dsAscii(char* filename,  Object* o);
///
int readScene3dsAscii(FILE* f, Scene* s) ;
///
int loadScene3dsAscii(char* filename, Scene* s) ;
///
int get3dsAscii(char* filename, Object* o) ;
///
int fprintScene(FILE* f, Scene const * const in);
///
int fprintObject(FILE*f, Object const * const o);
///
int saveObject(Object const * const in, char const * const filename);
///
int saveScene(Scene const *  const in, char const * const filename);
//int saveObject(Object* o, FILE* out = stdout);
///
int fgets_strcmp_token(FILE* f, char* buf) ;
///
int fgets_tag(FILE* f, char* buf, char** strarg);

#endif
