/* #ident "$Id: mini3dviewsdl.h,v 1.1.1.1 2004/03/30 12:09:38 rzr Exp $" */
/**
 * @author: www.Philippe.COVAL.online.fr - Rev: $Author: rzr $ 
 * Copyright: GPL @ http://rzr.online.fr/licence.htm
 **/

#ifndef mainsdl_h_
#define mainsdl_h_

#define USE_SDL_

#ifdef USE_SDL_
#include <SDL.h>
#include <SDL_endian.h>	/* Used for the endian-dependent 24 bpp mode */
SDL_Surface* screen;
#define VIDEO_PARAMS SDL_DOUBLEBUF | SDL_HWSURFACE 
#define mainSdl main
#else
#define main3ds main
#endif
//

#include "mini3d/types3d.h"

#ifdef USE_SDL_

void displayObject(SDL_Surface* screen, Object* o);


void traceSdl( Point* vPoint, int nVertex, Face* vFace, int nFace);
	       

void DrawPixelRGB(SDL_Surface *screen, int x, int y,
		  Uint8 R, Uint8 G, Uint8 B);

void DrawPixel(SDL_Surface *screen, int x, int y, Uint32 color);

#endif

void Line(int x1, int y1, int x2, int y2, Uint32 c);

void trace( Point* vPoint, int nVertex, Face* vFace, int nFace);

#endif //_h_
