/* #ident "$Id: include.h,v 1.1.1.1 2004/03/30 12:09:25 rzr Exp $" */
/**
 * @author: www.Philippe.COVAL.online.fr - Rev: $Author: rzr $ 
 * Copyright: GPL @ http://rzr.online.fr/licence.htm
 **/

#ifndef include_h_
#define include_h_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#ifdef WANT_MALLOC // might cause troubles on Macosx Project builder
#include <malloc.h>
#endif // !+Eye

#undef assert
#include <assert.h>


#define debugf  printf
#define debug(x) { debugf("%s\n",(x) ); }

#define assert1(x) { if ( x ) debugf("(%d)\n",y); assert( x);}
#define assert2eq(x,y) { if ( x != y) debugf("(%d<%d )\n",x,y); assert( x==y);}
#define assert2ne(x,y) { if ( x == y) debugf("(%d<%d )\n",x,y); assert( x!=y);}
#define assert2lt(x,y) { if ( x >= y) debugf("(%d<%d )\n",x,y); assert( x<y); }
#define assert2le(x,y) { if ( x > y) debugf("(%d<%d )\n",x,y); assert( x<=y); }
#define assert2gt(x,y) assert2lt(y,x)
#define assert2ge(x,y) assert2le(y,x)
#define assert3gl(x,y,z) { assert2ge(x,y); assert2le(y,z) };
#define assertpos(x) { assert2gt(x,0) }
#define assertneg(x) { assert2gt(0,x) }
#define assertz(x) { assert2eq(0,x) }

#ifndef abs
#define abs(x) ( ( (x)>0) ? (x) : (-x) )// @stdlib
#endif

#define min2(x,y) ( ((y)>(x)) ? (x) : (y) )
#define max2(x,y) ( ((y)<(x)) ? (x) : (y) )

#define min3(x,y,z) min2( min2(x,z) , min2(y,z) )
#define max3(x,y,z) max2( max2(x,z) , max2(y,z) )

#define min6(a,b,c,d,e,f) min2( min3(a,b,c) , min3(d,e,f) )
#define max6(a,b,c,d,e,f) max2( max3(a,b,c) , max3(d,e,f) )

#define float2int(x) ( (int) ( x + .5 ) )

#ifndef SQRT2
#define SQRT2 1.4142135f 
#endif

#ifndef Uint32
#define Uint32 unsigned int
#endif

#endif //_h_
